function groupDelay = calcGroupDelay(Hd, centerFrequencies, fs)
  %% groupDelay = calcGroupDelay(Hd, centerFrequencies, fs)
  % calculates the group delay for every bandpass filter in Hd at the
  % frequency defined in the vector centerFrequencies and given sampling
  % rate fs.
  %% calculate group delay
  groupDelay = zeros(size(Hd));
  parfor i=1:length(Hd)
    [g, w] = grpdelay(Hd(i));
    w = w/pi*fs/2;
    [~, index] = min(abs(w - centerFrequencies(i)));
    groupDelay(i) = g(index);
  end
end