function y = frequency_shift(x, f0, semitones, fs)
  % must be even to make sure we have an integer group delay!!!
  filterOrder = 80;
  
  % only mono
  t=(1:size(x, 1))';
  
  persistent Hd;
  if isempty(Hd)
    d = fdesign.hilbert('N,TW',filterOrder,0.01);
    Hd = design(d,'firls');
    set(Hd,'PersistentMemory',true);
  end
  
  x_hilbert = filter(Hd, x);
  
  % uncomment this line if you want to use Matlab's FFT based Hilbert
  % transform
  % x_hilbert = imag(hilbert(x));
  
  nSemitones = length(semitones);
  y = zeros(size(x,1), size(x,2), nSemitones);
  
  % no parallelization necessary since this is done in
  % filterbank_waveshaping.m
  for i=1:nSemitones
    if semitones(i) == 0
      y(:,:,i) = shiftd(x, 0, filterOrder/2);
    else
      dF = f0* 2^(semitones(i)/12) - f0;
      y(:,:,i) = shiftd(x, 0, filterOrder/2).*cos(t*2*pi*dF/fs) - x_hilbert.*sin(t*2*pi*dF/fs);
    end
  end
end