function Y = plot_dft(x, x_ref, fs)
    Y = fft(x);
    N = length(Y);
    X = Y(1:floor(N/2));
    
    if(nargin==3)
        X_ref = fft(x_ref);
        X_ref = X_ref(1:floor(N/2));
    end
    
    if(nargin==2)
        fs = x_ref;
    end
    
    n = (0:(N/2-1))/(N/2)*(fs/2);
    
    if(nargin==3)
        Y_max_db = 20*log10(max(abs(X_ref)));
    else
        Y_max_db = 20*log10(max(abs(X)));
    end
    
    if(nargin==3)
        plot(n, 20*log10(abs(X)) - Y_max_db, 'b', ...
             n, 20*log10(abs(X_ref)) - Y_max_db, 'r');
        legend('waveshaped','original');
    else
        plot(n, 20*log10(abs(X)) - Y_max_db);
    end
    xlim([n(1) n(end)]);
    xlabel('frequency in Hz');
    ylabel('normalized dB scale');
    grid on;
    ylim([-60 0]);
end