function plot_guitar(x, fs, description, x_ref, play_x)
    figure;
    
    if(nargin == 2)
        description = 'original';
    end
    
    if(nargin < 5)
      play_x = x;
    end
    
    function playAudio(gcbo, eventData)
      sound(play_x, fs);
    end
    
    % start and duration are reused for the zoomed in part
    start = 1;
    duration = 1000;
    timespan = (start):(start+duration-1);

    subplot(121);
    if(nargin >= 4)
        plot(timespan, x_ref(timespan), 'r--',...
            timespan, x(timespan), 'b');
    else
        plot(timespan, x(timespan));
    end
    title(['a) ' description ' signal']);
    xlabel('time in samples');
    ylabel('amplitude');
    grid on;
    set(gca,'ButtonDownFcn', @playAudio);
    set(get(gca,'Children'),'ButtonDownFcn', @playAudio);
    legend('click to play audio');

    subplot(222);
    plot(x);
    title(['b) ' description ' signal']);
    xlabel('time in samples');
    ylabel('amplitude');
    grid on;

    subplot(224);
    if nargin >= 4
        plot_dft(x, x_ref, fs);
    else
        plot_dft(x, fs);
    end
    title('c) DFT of input signal (zoomed)');
    %xlim([0 3000]);
end