function y = square_waveshaping_2(x)
    y = zeros(size(x));
    N = length(x);
    last_zero = 1;
    power = 0;
    delta_samples = 0;
    for k = 2:N
        if sign(x(k)) ~= sign(x(k-1)) && delta_samples > 0
            amplitude = power / delta_samples;
            for l = last_zero:k-1
                y(l) = amplitude;
            end
            last_zero = k;
            power = 0;
            delta_samples = 0;
        else
            power = power + x(k);
            delta_samples = delta_samples + 1;
        end
    end
    
    %% apply low pass filter
    %{
    Fp  = 0.3;
    Fst = 0.35;
    Ap  = 1;
    Ast = 60;
    Hf = fdesign.lowpass('Fp,Fst,Ap,Ast',Fp,Fst,Ap,Ast);
    Hd4 = design(Hf,'kaiserwin','SystemObject',true);
    y = step(Hd4, y);
    %}
    
    % normalize output if necessary
    if(max(y) > 1)
        y = y / max(y);
    end
end