function y = square_waveshaping_analog(x)
  % TODO: make suitable for stereo

  %x = iir_lpf(x);
  y = zeros(size(x));
  N = length(x);
  last_zero = 1;
  power = 0;
  delta_samples = 0;
  lambda = 0.5; % analog circuit step speed
  for k = 2:N
    if sign(x(k)) ~= sign(x(k-1)) && delta_samples > 0
      amplitude = power / delta_samples;

      if last_zero == 1, start = 0;
      else start = y(last_zero-1); end
      stepsize = amplitude - start;

      timespan = last_zero:k-1;
      y(timespan) = amplitude - stepsize*exp( lambda*(last_zero - timespan) );

      last_zero = k;
      power = 0;
      delta_samples = 0;
    else
      power = power + x(k);
      delta_samples = delta_samples + 1;
    end
  end
end