function y = triangle_waveshaping(x)
    y = zeros(size(x));
    N = length(x);
    m = 0;
    m0 = 0;
    k0 = 1;
    lambda = 0.95;
    for k=1:N
        if abs(x(k)) > abs(m*lambda)
            m = x(k);
            
            if(k0 ~= k)
                y(k0:k) = linear_interp([k0 k], [m0 m], k0:k);
            end
            
            m0 = m;
            k0 = k;
        else
            m = m*lambda;
        end
    end
end

%% custom linear interpolation function for two points
% This custom linear interpolation function is much faster than
% matlab's interp1 when given only two input points
function y_interp = linear_interp(X, Y, x_interp)
    x0 = X(1);
    x1 = X(2);
    y0 = Y(1);
    y1 = Y(2);
    y_interp = y0 + (y1 - y0) * (x_interp - x0) / (x1 - x0);
end