%% Waveshaping Summary.

%% Read input sample
[guitar, fs] = wavread('input/guitar_kontakt.wav');
x = guitar(:,1);

%% subsection of input
%x = x(1:30000);

%% Plot results
figure(1);
start = 1400;
duration = 1000;

if start > length(x) - duration
    start = length(x) - duration;
    disp('start point + duration exceeds sample length. choosing maximum');
end

timespan = (start):(start+duration-1);
subplot(431);
plot(x);
title('original signal');

subplot(432);
plot(timespan, x(timespan));
xlim([timespan(1) timespan(end)]);
title('original signal');
grid on;

figure(1);
subplot(433);
plot_dft(x, fs);
title('DFT of input signal');

%% square
y = square_waveshaping(x);
subplot(434);
plot(y, 'r');
title('square signal');

subplot(435);
plot(timespan, y(timespan), 'r');
xlim([timespan(1) timespan(end)]);
title('square signal');
grid on;

subplot(436);
Y = plot_dft(y, x, fs);
title('DFT of square signal');

%wavwrite(y, fs, 'waveshaper_overview/y_square.wav');

%% 8 bit
y = filter8bit(x);
subplot(4,3,7);
plot(x, 'g');
title('8bit filter');

subplot(4,3,8);
plot(timespan, filter8bit(x(timespan)), 'g');
xlim([timespan(1) timespan(end)]);
title('8bit filter');
grid on;

subplot(4,3,9);
plot_dft(y, x, fs);
title('DFT of 8bit signal');

%wavwrite(y, fs, 'waveshaper_overview/y_8bit.wav');

%% triangle filter
y = triangle_waveshaping(x);
subplot(4,3,11);
plot(y);
title('triangle filter');

subplot(4,3,11);
plot(timespan, y(timespan));
xlim([timespan(1) timespan(end)]);
title('triangle filter');
grid on;


subplot(4,3,12);
plot_dft(y, x, fs);
title('DFT of triangle filter');

%wavwrite(y, fs, 'waveshaper_overview/y_triangle.wav');