%% Wave Shaper Test Suite

%% Read input sample
[guitar, fs] = wavread('input/guitar_kontakt.wav');
%[guitar, fs] = wavread('guitar_e7_chord.wav');

guitar = guitar(1:round(length(guitar)/4)); % only one quarter

% limit singal
start = 1400;
duration = 10000;
x = guitar(start:(start+duration-1));

%% Plot results
plot_guitar(x, fs, 'original');


%% square
y = square_waveshaping(x);
guitar_y = square_waveshaping(guitar);
plot_guitar(y, fs, 'square', x, guitar_y);

%sound(guitar_y, fs);
wavwrite(guitar_y, fs, 'waveshaper_test/y_square.wav');

%% square 2
y = square_waveshaping_2(x);
guitar_y = square_waveshaping_2(guitar);
plot_guitar(y, fs, 'square 2', x, guitar_y);

%sound(guitar_y, fs);
wavwrite(guitar_y, fs, 'waveshaper_test/y_square2.wav');

%% square analog
y = square_waveshaping_analog(x);
guitar_y = square_waveshaping_analog(guitar);
plot_guitar(y, fs, 'square analog', x);

%sound(guitar_y, fs);
wavwrite(guitar_y, fs, 'waveshaper_test/y_square_analog.wav');

%% 8 bit
y = filter8bit(x);
guitar_y = filter8bit(guitar);
plot_guitar(y, fs, '8bit filter', x);

%sound(guitar_y, fs);
wavwrite(guitar_y, fs, 'waveshaper_test/y_8bit.wav');


%% triangle filter
y = triangle_waveshaping(x);
guitar_y = triangle_waveshaping(guitar);
plot_guitar(y, fs, 'triangle', x);

%sound(guitar_y, fs);
wavwrite(guitar_y, fs, 'waveshaper_test/y_triangle.wav');